# Copyright (c) 2000-2006 ActiveState Software Inc.
# See the file LICENSE.txt for licensing information.

# A simple encode/decode for passwords
# This is not meant to be anything extremely intelligent, just a
# way to avoid plain text passwords in preference files
#
# Contributors:
# * Shane Caraveo

from xpcom import file, components, COMException, ServerException, server, nsError
from xpcom.server.enumerator import SimpleEnumerator

# XXX We're obfuscating, not encrypting
import warnings, exceptions
warnings.filterwarnings('ignore', category=DeprecationWarning)
import rotor, base64

class koPasswordCrypto:
        _com_interfaces_ = [components.interfaces.koIPasswordCrypto]
        _reg_desc_ = "Komodo Password Crypto"
        _reg_contractid_ = "@activestate.com/koPasswordCrypto;1"
        _reg_clsid_ = "{3AA6007D-C0FE-4f7c-A6C6-4C7703801A58}"
        
        def __init__(self):
            self._rotor = rotor.newrotor(self._reg_clsid_) 

        def encodePassword(self, plaintext):
            ciphertext = self._rotor.encrypt(plaintext)
            return base64.encodestring(ciphertext)

        def decodePassword(self, ciphertext):
            ciphertext = base64.decodestring(ciphertext)
            return self._rotor.decrypt(ciphertext)

