# Copyright (c) 2000-2006 ActiveState Software Inc.
# See the file LICENSE.txt for licensing information.

from xpcom import components
import urllib

class koResourceMapper:
    _com_interfaces_ = [components.interfaces.koIResourceMapper]
    _reg_clsid_ = "{55A4BF64-CC7A-4857-B0A2-E3D9A836B0AA}"
    _reg_contractid_ = "@activestate.com/resource-mapper;1"
    
    def __init__(self):
        self._mappings = {}

    # this should be used by the debuggers, webdav servers, etc.
    def deleteMapping(self, source, protocol):
        try:
            del self._mappings[protocol][source]
        except AttributeError:
            pass

    def registerMapping(self, source, target, converter):
        protocol, junk = urllib.splittype(target)
        if not self._mappings.has_key(protocol):
            self._mappings[protocol] = {}
        self._mappings[protocol][source]=(target, converter)

    def mapURL(self, url, protocols=None):
        protocols = protocols or ["file","webdav","ftp","http","kodebugger"]
        currentproto, junk = urllib.splittype(url)
        for protocol in protocols:
            if protocol == currentproto:
                return url
            if self._mappings.has_key(protocol):
                for source, conversion in self._mappings[protocol].items():
                    if url.startswith(source):
                        target, converter = self._mappings[protocol][source]
                        if converter is None:
                            return url.replace(source, target)
                        else:
                            return converter.convert(source, target, url)
        return url
    
            

