#!python
# Copyright (c) 2000-2006 ActiveState Software Inc.
# See the file LICENSE.txt for licensing information.

from xpcom import components
import time

# A service for providing Komodo-specific directory/filename information.

class koStopwatch:
    _com_interfaces_ = [components.interfaces.koIStopwatch]
    _reg_clsid_ = "{9a71f2e3-1e20-464d-984d-296e95f0234b}"
    _reg_contractid_ = "@activestate.com/koStopwatch;1"
    _reg_desc_ = "Komodo Stopwatch Timing Service"

    def __init__(self):
        self._timers = {}

    def resetTimerFor(self, id):
        self._timers[id] = (0, 0)

    def startTimerFor(self, id):
        if not self._timers.has_key(id):
            self.resetTimerFor(id)
        elapsed, then = self._timers[id]
        assert then == 0
        now = time.clock()
        self._timers[id] = (elapsed, now)

    def stopTimerFor(self, id):
        elapsed, then = self._timers[id]
        assert then != 0
        now = time.clock()
        self._timers[id] = (elapsed + (now - then), 0)

    def readTimerFor(self, id):
        elapsed, then = self._timers[id]
        if then:
            now = time.clock()
            return elapsed + (now - then)
        else:
            return elapsed


if __name__ == "__main__":
  x = components.classes['@activestate.com/koStopwatch;1'].getService(components.interfaces.koIStopwatch);
  import time
  x.startTimerFor("test");
  time.sleep(1);
  x.stopTimerFor("test");
  print x.readTimerFor("test")

