#!/usr/bin/env python

from types import *

from xpcom import components


class koBoolean:
    _com_interfaces_ = [components.interfaces.koIBoolean]

    def __init__(self, value):
        if value not in [0, 1]:
            raise ValueError
        self.value = value

class koLong:
    _com_interfaces_ = [components.interfaces.koILong]

    def __init__(self, value):
        if type(value) is not IntType:
            raise TypeError
        self.value = value

class koDouble:
    _com_interfaces_ = [components.interfaces.koIDouble]

    def __init__(self, value):
        if type(value) is not FloatType:
            raise TypeError
        self.value = value

class koString:
    _com_interfaces_ = [components.interfaces.koIString]

    def __init__(self, value):
        if type(value) is not StringType:
            raise TypeError
        self.value = value

class koWString:
    _com_interfaces_ = [components.interfaces.koIWString]

    def __init__(self, value):
        if type(value) is not UnicodeType:
            raise TypeError
        self.value = value

