#!python
# Copyright (c) 2000-2006 ActiveState Software Inc.
# See the file LICENSE.txt for licensing information.

# Log object creation, and report leaks by keeping a weak-ref to the object.
#
# [TrentM: this is frightening: shouldn't be doing top-level stuff like
# this.]

infoService = None
tracked_classes = {}
try:
    import weakref
    def koLogInstanceCreation(instance):
        global tracked_classes, infoService, usingDeveloperBuild
        if infoService is None:
            from xpcom import components
            infoService = components.classes['@activestate.com/koInfoService;1'].getService(components.interfaces.koIInfoService)
            usingDeveloperBuild = infoService.buildFlavour == "dev"
        if not usingDeveloperBuild: return
        name = instance.__class__.__name__
        if not tracked_classes.has_key(name):
            tracked_classes[name] = []
        tracked_classes[name].append(weakref.ref(instance))
        
    def koReportLoggedInstances(classes): # "*" means all known instances
        if classes == '*':
            classes = tracked_classes.keys()
        else:
            classes = classes.split()
        classes.sort()
        for classname in classes:
            for ref in tracked_classes[classname]:
                ob = ref()
                if ob is not None:
                    print ref()
except ImportError:
    #print "Can't log instance creation because need Python 2.1 or greater"
    koLogInstanceCreation = lambda instance: None
    koReportLoggedInstances = lambda classes: None


