from xpcom import components
sm = components.interfaces.ISciMoz

stylemap = {
'Rx': {
    'default':0,
    'breakpoint':1,
    'child':2,
    'parent':3,
    },
'Ruby': {
    'word': sm.SCE_P_WORD,
    'identifier': sm.SCE_P_IDENTIFIER,
    'commentblock': sm.SCE_P_COMMENTBLOCK,
    'operator': sm.SCE_P_OPERATOR,
    'triple': sm.SCE_P_TRIPLE,
    'bracehighlight': sm.STYLE_BRACELIGHT,
    'tripledouble': sm.SCE_P_TRIPLEDOUBLE,
    'classname': sm.SCE_P_CLASSNAME,
    'number': sm.SCE_P_NUMBER,
    'character': sm.SCE_P_CHARACTER,
    'defname': sm.SCE_P_DEFNAME,
    'default': sm.SCE_P_DEFAULT,
    'string': sm.SCE_P_STRING,
    'stringeol': sm.SCE_P_STRINGEOL,
    'bracebad': sm.STYLE_BRACEBAD,
    'comment': sm.SCE_P_COMMENTLINE,
    },
'PHP': {
    'comment': sm.SCE_HPHP_COMMENT,
    'py-default': sm.SCE_HP_DEFAULT,
    'xmlend': sm.SCE_H_XMLEND,
    'js-default': sm.SCE_HJ_DEFAULT,
    'vbs-start': sm.SCE_HB_START,
    'py-string': sm.SCE_HP_STRING,
    'vbs-number': sm.SCE_HB_NUMBER,
    'js-stringeol': sm.SCE_HJ_STRINGEOL,
    'py-classname': sm.SCE_HP_CLASSNAME,
    'value': sm.SCE_H_VALUE,
    'php-commentline': sm.SCE_HPHP_COMMENTLINE,
    'vbs-identifier': sm.SCE_HB_IDENTIFIER,
    'vbs-comment': sm.SCE_HB_COMMENTLINE,
    'js-keyword': sm.SCE_HJ_KEYWORD,
    'default': sm.SCE_H_DEFAULT,
    'xmlstart': sm.SCE_H_XMLSTART,
    'php-number': sm.SCE_HPHP_NUMBER,
    'py-defname': sm.SCE_HP_DEFNAME,
    'hcomment': sm.SCE_H_COMMENT,
    'py-start': sm.SCE_HP_START,
    'tagunknown': sm.SCE_H_TAGUNKNOWN,
    'singlestring': sm.SCE_H_SINGLESTRING,
    'js-singlestring': sm.SCE_HJ_SINGLESTRING,
    'tagend': sm.SCE_H_TAGEND,
    'js-commentdoc': sm.SCE_HJ_COMMENTDOC,
    'py-comment': sm.SCE_HP_COMMENTLINE,
    'js-regex': sm.SCE_HJ_REGEX,
    'aspat': sm.SCE_H_ASPAT,
    'php-comment': sm.SCE_HPHP_COMMENT,
    'py-identifier': sm.SCE_HP_IDENTIFIER,
    'py-word': sm.SCE_HP_WORD,
    'vbs-word': sm.SCE_HB_WORD,
    'asp': sm.SCE_H_ASP,
    'attributeunknown': sm.SCE_H_ATTRIBUTEUNKNOWN,
    'py-number': sm.SCE_HP_NUMBER,
    'py-triple': sm.SCE_HP_TRIPLE,
    'vbs-string': sm.SCE_HB_STRING,
    'php-word': sm.SCE_HPHP_WORD,
    'py-char': sm.SCE_HP_CHARACTER,
    'other': sm.SCE_H_OTHER,
    'js-start': sm.SCE_HJ_START,
    'js-doublestring': sm.SCE_HJ_DOUBLESTRING,
    'question': sm.SCE_H_QUESTION,
    'js-comment': sm.SCE_HJ_COMMENT,
    'php-hstring': sm.SCE_HPHP_HSTRING,
    'script': sm.SCE_H_SCRIPT,
    'py-tripledouble': sm.SCE_HP_TRIPLEDOUBLE,
    'number': sm.SCE_H_NUMBER,
    'js-number': sm.SCE_HJ_NUMBER,
    'js-symbols': sm.SCE_HJ_SYMBOLS,
    'php-variable': sm.SCE_HPHP_VARIABLE,
    'cdata': sm.SCE_H_CDATA,
    'attribute': sm.SCE_H_ATTRIBUTE,
    'vbs-stringeol': sm.SCE_HB_STRINGEOL,
    'tag': sm.SCE_H_TAG,
    'entity': sm.SCE_H_ENTITY,
    'js-commentline': sm.SCE_HJ_COMMENTLINE,
    'doublestring': sm.SCE_H_DOUBLESTRING,
    'js-word': sm.SCE_HJ_WORD,
    'php-simplestring': sm.SCE_HPHP_SIMPLESTRING,
    'py-operator': sm.SCE_HP_OPERATOR,
    'php-default': sm.SCE_HPHP_DEFAULT,
    'vbs-default': sm.SCE_HB_DEFAULT,
    "php-operator": sm.SCE_HPHP_OPERATOR,
    'bracehighlight': sm.STYLE_BRACELIGHT,
    'bracebad': sm.STYLE_BRACEBAD,
    'xccomment': sm.SCE_H_XCCOMMENT,
    'sgml-default': sm.SCE_H_SGML_DEFAULT,
    'sgml-command': sm.SCE_H_SGML_COMMAND,
    'sgml-1st-param': sm.SCE_H_SGML_1ST_PARAM,
    'sgml-doublestring': sm.SCE_H_SGML_DOUBLESTRING,
    'sgml-simplestring': sm.SCE_H_SGML_SIMPLESTRING,
    'sgml-error': sm.SCE_H_SGML_ERROR,
    'sgml-special': sm.SCE_H_SGML_SPECIAL,
    'sgml-entity': sm.SCE_H_SGML_ENTITY,
    'sgml-comment': sm.SCE_H_SGML_COMMENT,
    'sgml-1st-param-comment': sm.SCE_H_SGML_1ST_PARAM_COMMENT,
    'sgml-block-default': sm.SCE_H_SGML_BLOCK_DEFAULT,
    'js-asp-start': sm.SCE_HJA_START,
    'js-asp-default': sm.SCE_HJA_DEFAULT,
    'js-asp-comment': sm.SCE_HJA_COMMENT,
    'js-asp-commentline': sm.SCE_HJA_COMMENTLINE,
    'js-asp-commentdoc': sm.SCE_HJA_COMMENTDOC,
    'js-asp-number': sm.SCE_HJA_NUMBER,
    'js-asp-word': sm.SCE_HJA_WORD,
    'js-asp-keyword': sm.SCE_HJA_KEYWORD,
    'js-asp-doublestring': sm.SCE_HJA_DOUBLESTRING,
    'js-asp-singlestring': sm.SCE_HJA_SINGLESTRING,
    'js-asp-symbols': sm.SCE_HJA_SYMBOLS,
    'js-asp-stringeol': sm.SCE_HJA_STRINGEOL,
    'js-asp-regex': sm.SCE_HJA_REGEX,
    'vbs-asp-start': sm.SCE_HBA_START,
    'vbs-asp-default': sm.SCE_HBA_DEFAULT,
    'vbs-asp-comment': sm.SCE_HBA_COMMENTLINE,
    'vbs-asp-number': sm.SCE_HBA_NUMBER,
    'vbs-asp-word': sm.SCE_HBA_WORD,
    'vbs-asp-string': sm.SCE_HBA_STRING,
    'vbs-asp-identifier': sm.SCE_HBA_IDENTIFIER,
    'vbs-asp-stringeol': sm.SCE_HBA_STRINGEOL,
    'py-asp-start': sm.SCE_HPA_START,
    'py-asp-default': sm.SCE_HPA_DEFAULT,
    'py-asp-comment': sm.SCE_HPA_COMMENTLINE,
    'py-asp-number': sm.SCE_HPA_NUMBER,
    'py-asp-string': sm.SCE_HPA_STRING,
    'py-asp-char': sm.SCE_HPA_CHARACTER,
    'py-asp-word': sm.SCE_HPA_WORD,
    'py-asp-triple': sm.SCE_HPA_TRIPLE,
    'py-asp-tripledouble': sm.SCE_HPA_TRIPLEDOUBLE,
    'py-asp-classname': sm.SCE_HPA_CLASSNAME,
    'py-asp-defname': sm.SCE_HPA_DEFNAME,
    'py-asp-operator': sm.SCE_HPA_OPERATOR,
    'py-asp-identifier': sm.SCE_HPA_IDENTIFIER,
    'php-hstring-variable': sm.SCE_HPHP_HSTRING_VARIABLE,
  },
'Diff': {
    'diffline': 3,
    'fileline': 2,
    'default': 0,
    'context': 1,
    'deletionline': 5,
    'chunkheader': 4,
    'additionline': 6,
    },
'SQL': {
    'number': sm.SCE_C_NUMBER,
    'identifier': sm.SCE_C_IDENTIFIER,
    'default': sm.SCE_C_DEFAULT,
    'commentline': sm.SCE_C_COMMENTLINE,
    'string': sm.SCE_C_STRING,
    'word': sm.SCE_C_WORD,
    'operator': sm.SCE_C_OPERATOR,
    'comment': sm.SCE_C_COMMENT,
    },
'HTML': {
    'py-default': sm.SCE_HP_DEFAULT,
    'xmlend': sm.SCE_H_XMLEND,
    'js-default': sm.SCE_HJ_DEFAULT,
    'vbs-start': sm.SCE_HB_START,
    'py-string': sm.SCE_HP_STRING,
    'vbs-number': sm.SCE_HB_NUMBER,
    'js-stringeol': sm.SCE_HJ_STRINGEOL,
    'py-classname': sm.SCE_HP_CLASSNAME,
    'value': sm.SCE_H_VALUE,
    'php-commentline': sm.SCE_HPHP_COMMENTLINE,
    'vbs-identifier': sm.SCE_HB_IDENTIFIER,
    'vbs-comment': sm.SCE_HB_COMMENTLINE,
    'js-keyword': sm.SCE_HJ_KEYWORD,
    'php-number': sm.SCE_HPHP_NUMBER,
    'default': sm.SCE_H_DEFAULT,
    'xmlstart': sm.SCE_H_XMLSTART,
    'comment': sm.SCE_H_COMMENT,
    'py-defname': sm.SCE_HP_DEFNAME,
    'py-start': sm.SCE_HP_START,
    'tagunknown': sm.SCE_H_TAGUNKNOWN,
    'singlestring': sm.SCE_H_SINGLESTRING,
    'js-singlestring': sm.SCE_HJ_SINGLESTRING,
    'tagend': sm.SCE_H_TAGEND,
    'js-commentdoc': sm.SCE_HJ_COMMENTDOC,
    'py-comment': sm.SCE_HP_COMMENTLINE,
    'js-regex': sm.SCE_HJ_REGEX,
    'aspat': sm.SCE_H_ASPAT,
    'php-comment': sm.SCE_HPHP_COMMENT,
    'py-identifier': sm.SCE_HP_IDENTIFIER,
    'py-word': sm.SCE_HP_WORD,
    'vbs-word': sm.SCE_HB_WORD,
    'asp': sm.SCE_H_ASP,
    'attributeunknown': sm.SCE_H_ATTRIBUTEUNKNOWN,
    'py-number': sm.SCE_HP_NUMBER,
    'py-triple': sm.SCE_HP_TRIPLE,
    'vbs-string': sm.SCE_HB_STRING,
    'php-word': sm.SCE_HPHP_WORD,
    'py-char': sm.SCE_HP_CHARACTER,
    'other': sm.SCE_H_OTHER,
    'js-start': sm.SCE_HJ_START,
    'js-doublestring': sm.SCE_HJ_DOUBLESTRING,
    'question': sm.SCE_H_QUESTION,
    'js-comment': sm.SCE_HJ_COMMENT,
    'php-hstring': sm.SCE_HPHP_HSTRING,
    'script': sm.SCE_H_SCRIPT,
    'py-tripledouble': sm.SCE_HP_TRIPLEDOUBLE,
    'number': sm.SCE_H_NUMBER,
    'js-number': sm.SCE_HJ_NUMBER,
    'js-symbols': sm.SCE_HJ_SYMBOLS,
    'php-variable': sm.SCE_HPHP_VARIABLE,
    'cdata': sm.SCE_H_CDATA,
    'attribute': sm.SCE_H_ATTRIBUTE,
    'vbs-stringeol': sm.SCE_HB_STRINGEOL,
    'tag': sm.SCE_H_TAG,
    'entity': sm.SCE_H_ENTITY,
    'js-commentline': sm.SCE_HJ_COMMENTLINE,
    'doublestring': sm.SCE_H_DOUBLESTRING,
    'js-word': sm.SCE_HJ_WORD,
    'php-simplestring': sm.SCE_HPHP_SIMPLESTRING,
    'py-operator': sm.SCE_HP_OPERATOR,
    'php-default': sm.SCE_HPHP_DEFAULT,
    'vbs-default': sm.SCE_HB_DEFAULT,
    'xccomment': sm.SCE_H_XCCOMMENT,
    'sgml-default': sm.SCE_H_SGML_DEFAULT,
    'sgml-command': sm.SCE_H_SGML_COMMAND,
    'sgml-1st-param': sm.SCE_H_SGML_1ST_PARAM,
    'sgml-doublestring': sm.SCE_H_SGML_DOUBLESTRING,
    'sgml-simplestring': sm.SCE_H_SGML_SIMPLESTRING,
    'sgml-error': sm.SCE_H_SGML_ERROR,
    'sgml-special': sm.SCE_H_SGML_SPECIAL,
    'sgml-entity': sm.SCE_H_SGML_ENTITY,
    'sgml-comment': sm.SCE_H_SGML_COMMENT,
    'sgml-1st-param-comment': sm.SCE_H_SGML_1ST_PARAM_COMMENT,
    'sgml-block-default': sm.SCE_H_SGML_BLOCK_DEFAULT,
    'js-asp-start': sm.SCE_HJA_START,
    'js-asp-default': sm.SCE_HJA_DEFAULT,
    'js-asp-comment': sm.SCE_HJA_COMMENT,
    'js-asp-commentline': sm.SCE_HJA_COMMENTLINE,
    'js-asp-commentdoc': sm.SCE_HJA_COMMENTDOC,
    'js-asp-number': sm.SCE_HJA_NUMBER,
    'js-asp-word': sm.SCE_HJA_WORD,
    'js-asp-keyword': sm.SCE_HJA_KEYWORD,
    'js-asp-doublestring': sm.SCE_HJA_DOUBLESTRING,
    'js-asp-singlestring': sm.SCE_HJA_SINGLESTRING,
    'js-asp-symbols': sm.SCE_HJA_SYMBOLS,
    'js-asp-stringeol': sm.SCE_HJA_STRINGEOL,
    'js-asp-regex': sm.SCE_HJA_REGEX,
    'vbs-asp-start': sm.SCE_HBA_START,
    'vbs-asp-default': sm.SCE_HBA_DEFAULT,
    'vbs-asp-comment': sm.SCE_HBA_COMMENTLINE,
    'vbs-asp-number': sm.SCE_HBA_NUMBER,
    'vbs-asp-word': sm.SCE_HBA_WORD,
    'vbs-asp-string': sm.SCE_HBA_STRING,
    'vbs-asp-identifier': sm.SCE_HBA_IDENTIFIER,
    'vbs-asp-stringeol': sm.SCE_HBA_STRINGEOL,
    'py-asp-start': sm.SCE_HPA_START,
    'py-asp-default': sm.SCE_HPA_DEFAULT,
    'py-asp-comment': sm.SCE_HPA_COMMENTLINE,
    'py-asp-number': sm.SCE_HPA_NUMBER,
    'py-asp-string': sm.SCE_HPA_STRING,
    'py-asp-char': sm.SCE_HPA_CHARACTER,
    'py-asp-word': sm.SCE_HPA_WORD,
    'py-asp-triple': sm.SCE_HPA_TRIPLE,
    'py-asp-tripledouble': sm.SCE_HPA_TRIPLEDOUBLE,
    'py-asp-classname': sm.SCE_HPA_CLASSNAME,
    'py-asp-defname': sm.SCE_HPA_DEFNAME,
    'py-asp-operator': sm.SCE_HPA_OPERATOR,
    'py-asp-identifier': sm.SCE_HPA_IDENTIFIER,
    'php-hstring-variable': sm.SCE_HPHP_HSTRING_VARIABLE,
    },
'Pascal': {
    'commentdoc': sm.SCE_C_COMMENTDOC,
    'identifier': sm.SCE_C_IDENTIFIER,
    'operator': sm.SCE_C_OPERATOR,
    'commentline': sm.SCE_C_COMMENTLINE,
    'preprocessor': sm.SCE_C_PREPROCESSOR,
    'bracebad': sm.STYLE_BRACEBAD,
    'number': sm.SCE_C_NUMBER,
    'character': sm.SCE_C_CHARACTER,
    'default': sm.SCE_C_DEFAULT,
    'string': sm.SCE_C_STRING,
    'word': sm.SCE_C_WORD,
    'bracehighlight': sm.STYLE_BRACELIGHT,
    'comment': sm.SCE_C_COMMENT,
  }, 'Text': {
    'default': sm.SCE_P_DEFAULT,
  }, 'Python': { 
    'word': sm.SCE_P_WORD,
    'identifier': sm.SCE_P_IDENTIFIER,
    'commentblock': sm.SCE_P_COMMENTBLOCK,
    'operator': sm.SCE_P_OPERATOR,
    'triple': sm.SCE_P_TRIPLE,
    'bracehighlight': sm.STYLE_BRACELIGHT,
    'tripledouble': sm.SCE_P_TRIPLEDOUBLE,
    'classname': sm.SCE_P_CLASSNAME,
    'number': sm.SCE_P_NUMBER,
    'character': sm.SCE_P_CHARACTER,
    'defname': sm.SCE_P_DEFNAME,
    'default': sm.SCE_P_DEFAULT,
    'string': sm.SCE_P_STRING,
    'stringeol': sm.SCE_P_STRINGEOL,
    'bracebad': sm.STYLE_BRACEBAD,
    'comment': sm.SCE_P_COMMENTLINE,
  }, 'VisualBasic': {
    'number': sm.SCE_B_NUMBER,
    'preprocessor': sm.SCE_B_PREPROCESSOR,
    'operator': sm.SCE_B_OPERATOR,
    'commentline': sm.SCE_B_COMMENT,
    'string': sm.SCE_B_STRING,
    'word': sm.SCE_B_KEYWORD,
    'date': sm.SCE_B_DATE,
    'default': sm.SCE_B_DEFAULT,
  }, 'C#': {
    'character': sm.SCE_C_CHARACTER,
    'commentlinedoc': sm.SCE_C_COMMENTLINEDOC,
    'commentdoc': sm.SCE_C_COMMENTDOC,
    'word': sm.SCE_C_WORD,
    'operator': sm.SCE_C_OPERATOR,
    'commentline': sm.SCE_C_COMMENTLINE,
    'preprocessor': sm.SCE_C_PREPROCESSOR,
    'bracebad': sm.STYLE_BRACEBAD,
    'number': sm.SCE_C_NUMBER,
    'default': sm.SCE_C_DEFAULT,
    'keyword': sm.SCE_C_IDENTIFIER,
    'string': sm.SCE_C_STRING,
    'stringeol': sm.SCE_C_STRINGEOL,
    'bracehighlight': sm.STYLE_BRACELIGHT,
    'comment': sm.SCE_C_COMMENT,
  }, 'Ada': {
    'number': sm.SCE_ADA_NUMBER,
    'character': sm.SCE_ADA_CHARACTER,
    'identifier': sm.SCE_ADA_IDENTIFIER,
    'default': sm.SCE_ADA_DEFAULT,
    'stringeol': sm.SCE_ADA_STRINGEOL,
    'string': sm.SCE_ADA_STRING,
    'label': sm.SCE_ADA_LABEL,
    'word': sm.SCE_ADA_WORD,
    'comment': sm.SCE_ADA_COMMENTLINE,
    'illegal': sm.SCE_ADA_ILLEGAL,
  }, 'IDL': {
    'commentlinedoc': sm.SCE_C_COMMENTLINEDOC,
    'character': sm.SCE_C_CHARACTER,
    'commentdoc': sm.SCE_C_COMMENTDOC,
    'string': sm.SCE_C_STRING,
    'preprocessor': sm.SCE_C_PREPROCESSOR,
    'commentline': sm.SCE_C_COMMENTLINE,
    'operator': sm.SCE_C_OPERATOR,
    'stringeol': sm.SCE_C_STRINGEOL,
    'bracebad': sm.STYLE_BRACEBAD,
    'number': sm.SCE_C_NUMBER,
    'default': sm.SCE_C_DEFAULT,
    'keyword': sm.SCE_C_IDENTIFIER,
    'uuid': sm.SCE_C_UUID,
    'word': sm.SCE_C_WORD,
    'bracehighlight': sm.STYLE_BRACELIGHT,
    'comment': sm.SCE_C_COMMENT,
  }, 'Lua': {
    'commentdoc': sm.SCE_LUA_COMMENTDOC,
    'identifier': sm.SCE_LUA_IDENTIFIER,
    'operator': sm.SCE_LUA_OPERATOR,
    'commentline': sm.SCE_LUA_COMMENTLINE,
    'preprocessor': sm.SCE_LUA_PREPROCESSOR,
    'stringeol': sm.SCE_LUA_STRINGEOL,
    'bracebad': sm.STYLE_BRACEBAD,
    'number': sm.SCE_LUA_NUMBER,
    'character': sm.SCE_LUA_CHARACTER,
    'default': sm.SCE_LUA_DEFAULT,
    'string': sm.SCE_LUA_STRING,
    'word': sm.SCE_LUA_WORD,
    'word2': sm.SCE_LUA_WORD2,
    'word3': sm.SCE_LUA_WORD3,
    'word4': sm.SCE_LUA_WORD4,
    'word5': sm.SCE_LUA_WORD5,
    'word6': sm.SCE_LUA_WORD6,
    'literalstring': sm.SCE_LUA_LITERALSTRING,
    'bracehighlight': sm.STYLE_BRACELIGHT,
    'comment': sm.SCE_LUA_COMMENT,
  }, 'Perl': {
    'backticks': sm.SCE_PL_BACKTICKS,
    'string_q': sm.SCE_PL_STRING_Q,
    'bracehighlight': sm.STYLE_BRACELIGHT,
    'here_document_delim': sm.SCE_PL_HERE_DELIM,
    'here_document': sm.SCE_PL_HERE_Q,
    'symboltable': sm.SCE_PL_SYMBOLTABLE,
    'longquote': sm.SCE_PL_LONGQUOTE,
    'datasection': sm.SCE_PL_DATASECTION,
    'character': sm.SCE_PL_CHARACTER,
    'punctuation': sm.SCE_PL_PUNCTUATION,
    'default': sm.SCE_PL_DEFAULT,
    'string_qw': sm.SCE_PL_STRING_QW,
    'word': sm.SCE_PL_WORD,
    'string_qr': sm.SCE_PL_STRING_QR,
    'array': sm.SCE_PL_ARRAY,
    'regex': sm.SCE_PL_REGEX,
    'regsubst': sm.SCE_PL_REGSUBST,
    'pod': sm.SCE_PL_POD,
    'operator': sm.SCE_PL_OPERATOR,
    'commentline': sm.SCE_PL_COMMENTLINE,
    'preprocessor': sm.SCE_PL_PREPROCESSOR,
    'string_qq': sm.SCE_PL_STRING_QQ,
    'scalar': sm.SCE_PL_SCALAR,
    'number': sm.SCE_PL_NUMBER,
    'identifier': sm.SCE_PL_IDENTIFIER,
    'string': sm.SCE_PL_STRING,
    'hash': sm.SCE_PL_HASH,
    'bracebad': sm.STYLE_BRACEBAD,
    'variable_indexer': sm.SCE_PL_VARIABLE_INDEXER,
    'unknown_field': sm.SCE_PL_UNKNOWN_FIELD,
  }, 'C++': {
    'commentdoc': sm.SCE_C_COMMENTDOC,
    'word': sm.SCE_C_WORD,
    'operator': sm.SCE_C_OPERATOR,
    'commentline': sm.SCE_C_COMMENTLINE,
    'preprocessor': sm.SCE_C_PREPROCESSOR,
    'bracebad': sm.STYLE_BRACEBAD,
    'number': sm.SCE_C_NUMBER,
    'default': sm.SCE_C_DEFAULT,
    'keyword': sm.SCE_C_IDENTIFIER,
    'string': sm.SCE_C_STRING,
    'stringeol': sm.SCE_C_STRINGEOL,
    'bracehighlight': sm.STYLE_BRACELIGHT,
    'comment': sm.SCE_C_COMMENT,
    'commentlinedoc': sm.SCE_C_COMMENTLINEDOC,
    'character': sm.SCE_C_CHARACTER,
    'commentdockeyword': sm.SCE_C_COMMENTDOCKEYWORD,
    'commentdockeyworderror': sm.SCE_C_COMMENTDOCKEYWORDERROR,
  }, 'Bullant': {
    'keyword': sm.SCE_C_IDENTIFIER,
    'word': sm.SCE_C_WORD,
    'number': sm.SCE_C_NUMBER,
    'string': sm.SCE_C_STRING,
    'stringeol': sm.SCE_C_STRINGEOL,
    'commentline': sm.SCE_C_COMMENTLINE,
    'character': sm.SCE_C_CHARACTER,
    'operator': sm.SCE_C_OPERATOR,
    'comment': sm.SCE_C_COMMENT,
    'bracebad': sm.STYLE_BRACEBAD,
    'default': sm.SCE_C_DEFAULT,
    'bracehighlight': sm.STYLE_BRACELIGHT,
  }, 'Makefile': {
    'bracehighlight': sm.STYLE_BRACELIGHT,
    'operator': sm.SCE_MAKE_OPERATOR,
    'bracebad': sm.STYLE_BRACEBAD,
    'bracehighlight': sm.STYLE_BRACELIGHT,
    'default': sm.SCE_MAKE_DEFAULT,
    'error': sm.SCE_MAKE_IDEOL,
    'preprocessor': sm.SCE_MAKE_PREPROCESSOR,
    'variable': sm.SCE_MAKE_IDENTIFIER,
    'comment': sm.SCE_MAKE_COMMENT,
    'target': sm.SCE_MAKE_TARGET,
  }, 'JavaScript': { 
    'commentdoc': sm.SCE_C_COMMENTDOC,
    'operator': sm.SCE_C_OPERATOR,
    'commentline': sm.SCE_C_COMMENTLINE,
    'preprocessor': sm.SCE_C_PREPROCESSOR,
    'stringeol': sm.SCE_C_STRINGEOL,
    'bracebad': sm.STYLE_BRACEBAD,
    'number': sm.SCE_C_NUMBER,
    'character': sm.SCE_C_CHARACTER,
    'default': sm.SCE_C_DEFAULT,
    'keyword': sm.SCE_C_IDENTIFIER,
    'string': sm.SCE_C_STRING,
    'word': sm.SCE_C_WORD,
    'bracehighlight': sm.STYLE_BRACELIGHT,
    'comment': sm.SCE_C_COMMENT,
    'commentlinedoc': sm.SCE_C_COMMENTLINEDOC,
    'regex': sm.SCE_C_REGEX,
  }, 'Lisp': {
    'number': sm.SCE_LISP_NUMBER,
    'identifier': sm.SCE_LISP_IDENTIFIER,
    'default': sm.SCE_LISP_DEFAULT,
    'keyword': sm.SCE_LISP_KEYWORD,
    'string': sm.SCE_LISP_STRING,
    'stringeol': sm.SCE_LISP_STRINGEOL,
    'operator': sm.SCE_LISP_OPERATOR,
    'comment': sm.SCE_LISP_COMMENT,
  }, 'XSLT': {
    'prolog': sm.SCE_XML_PROLOG,
    'xml_decl_close': sm.SCE_XML_XML_DECL_CLOSE,
    'start_tag_attr_apos_content': sm.SCE_XML_START_TAG_ATTR_APOS_CONTENT,
    'start_tag_attr_equals': sm.SCE_XML_START_TAG_ATTR_EQUALS,
    'end_tag_open': sm.SCE_XML_END_TAG_OPEN,
    'xml_decl_content': sm.SCE_XML_XML_DECL_CONTENT,
    'start_tag_attr_apos_close': sm.SCE_XML_START_TAG_ATTR_APOS_CLOSE,
    'comment_close': sm.SCE_XML_COMMENT_CLOSE,
    'char_ref': sm.SCE_XML_CHAR_REF,
    'entity_ref': sm.SCE_XML_ENTITY_REF,
    'end_tag_close': sm.SCE_XML_END_TAG_CLOSE,
    'upper_bound': sm.SCE_XML_UPPER_BOUND,
    'start_tag_attr_quot_content': sm.SCE_XML_START_TAG_ATTR_QUOT_CONTENT,
    'pi_open': sm.SCE_XML_PI_OPEN,
    'pi_content': sm.SCE_XML_PI_CONTENT,
    'default': sm.SCE_XML_DEFAULT,
    'start_tag_empty_close': sm.SCE_XML_START_TAG_EMPTY_CLOSE,
    'start_tag_open': sm.SCE_XML_START_TAG_OPEN,
    'cdata_sect_close': sm.SCE_XML_CDATA_SECT_CLOSE,
    'start_tag_attr_number': sm.SCE_XML_START_TAG_ATTR_NUMBER,
    'xml_decl_open': sm.SCE_XML_XML_DECL_OPEN,
    'start_tag_name': sm.SCE_XML_START_TAG_NAME,
    'xpath_attr_name': sm.SCE_XPATH_ATTR_NAME,
    'comment_content': sm.SCE_XML_COMMENT_CONTENT,
    'xpath_tag_name': sm.SCE_XPATH_TAG_NAME,
    'cdata_sect_content': sm.SCE_XML_CDATA_SECT_CONTENT,
    'xpath_content_quot': sm.SCE_XPATH_CONTENT_QUOT,
    'start_tag_attr_apos_open': sm.SCE_XML_START_TAG_ATTR_APOS_OPEN,
    'xpath_content_apos': sm.SCE_XPATH_CONTENT_APOS,
    'start_tag_attr_quot_open': sm.SCE_XML_START_TAG_ATTR_QUOT_OPEN,
    'pi_close': sm.SCE_XML_PI_CLOSE,
    'xpath_close': sm.SCE_XPATH_CLOSE,
    'xpath_open': sm.SCE_XPATH_OPEN,
    'bom': sm.SCE_XML_BOM,
    'comment_open': sm.SCE_XML_COMMENT_OPEN,
    'start_tag_attr_quot_close': sm.SCE_XML_START_TAG_ATTR_QUOT_CLOSE,
    'start_tag_attr_name': sm.SCE_XML_START_TAG_ATTR_NAME,
    'cdata_sect_open': sm.SCE_XML_CDATA_SECT_OPEN,
    'end_tag_name': sm.SCE_XML_END_TAG_NAME,
    'start_tag_close': sm.SCE_XML_START_TAG_CLOSE,
    'data_newline': sm.SCE_XML_DATA_NEWLINE,
    'data_chars': sm.SCE_XML_DATA_CHARS,
    'start_tag_white_space': sm.SCE_XML_START_TAG_WHITE_SPACE,
    'start_tag_attr_unquoted': sm.SCE_XML_START_TAG_ATTR_UNQUOTED,
    'end_tag_white_space': sm.SCE_XML_END_TAG_WHITE_SPACE,
    'declaration_open': sm.SCE_XML_DECLARATION_OPEN,
    'declaration_type': sm.SCE_XML_DECLARATION_TYPE,
    'decln_white_space': sm.SCE_XML_DECLN_WHITE_SPACE,
    'decln_name': sm.SCE_XML_DECLN_NAME,
    'decln_close': sm.SCE_XML_DECLN_CLOSE,
    'decln_quot_content': sm.SCE_XML_DECLN_QUOT_CONTENT,
    'decln_apos_content': sm.SCE_XML_DECLN_APOS_CONTENT,
    'decln_data_chars': sm.SCE_XML_DECLN_DATA_CHARS,
  }, 'Apache': { 
    'directive': sm.SCE_CONF_DIRECTIVE,
    'ip_address': sm.SCE_CONF_IP,
    'comment': sm.SCE_CONF_COMMENT,
    'number': sm.SCE_CONF_NUMBER,
    'identifier': sm.SCE_CONF_IDENTIFIER,
    'extensions': sm.SCE_CONF_EXTENSION,
    'parameter': sm.SCE_CONF_PARAMETER,
    'string': sm.SCE_CONF_STRING,
    'operator': sm.SCE_CONF_OPERATOR,

  }, 'Fortran 77': {
    'comment': sm.SCE_F_COMMENT,
    'number': sm.SCE_F_NUMBER,
    'single_string': sm.SCE_F_STRING1,
    'double_string': sm.SCE_F_STRING2,
    'stringeol': sm.SCE_F_STRINGEOL,
    'operator': sm.SCE_F_OPERATOR2,
    'identifier': sm.SCE_F_IDENTIFIER,
    'keyword': sm.SCE_F_WORD,
    'intrinsic_extended_functions': sm.SCE_F_WORD2,
    'other_functions': sm.SCE_F_WORD3,
    'preprocessor': sm.SCE_F_PREPROCESSOR,
    '.operator.': sm.SCE_F_OPERATOR2,
    'label': sm.SCE_F_LABEL,
    'continuation': sm.SCE_F_CONTINUATION,
  }, 'Fortran': {
    'comment': sm.SCE_F_COMMENT,
    'number': sm.SCE_F_NUMBER,
    'single_string': sm.SCE_F_STRING1,
    'double_string': sm.SCE_F_STRING2,
    'stringeol': sm.SCE_F_STRINGEOL,
    'operator': sm.SCE_F_OPERATOR2,
    'identifier': sm.SCE_F_IDENTIFIER,
    'keyword': sm.SCE_F_WORD,
    'intrinsic_extended_functions': sm.SCE_F_WORD2,
    'other_functions': sm.SCE_F_WORD3,
    'preprocessor': sm.SCE_F_PREPROCESSOR,
    '.operator.': sm.SCE_F_OPERATOR2,
    'label': sm.SCE_F_LABEL,
    'continuation': sm.SCE_F_CONTINUATION,

  }, 'Tcl': {
    'identifier': sm.SCE_TCL_IDENTIFIER,
    'array': sm.SCE_TCL_ARRAY,
    'operator': sm.SCE_TCL_OPERATOR,
    'variable': sm.SCE_TCL_VARIABLE,
    'literal': sm.SCE_TCL_LITERAL,
    'eol': sm.SCE_TCL_EOL,
    'bracebad': sm.STYLE_BRACEBAD,
    'number': sm.SCE_TCL_NUMBER,
    'character': sm.SCE_TCL_CHARACTER,
    'default': sm.SCE_TCL_DEFAULT,
    'string': sm.SCE_TCL_STRING,
    'word': sm.SCE_TCL_WORD,
    'bracehighlight': sm.STYLE_BRACELIGHT,
    'comment': sm.SCE_TCL_COMMENT,
  }, 'Java': {
    'commentlinedoc': sm.SCE_C_COMMENTLINEDOC,
    'character': sm.SCE_C_CHARACTER,
    'commentdoc': sm.SCE_C_COMMENTDOC,
    'word': sm.SCE_C_WORD,
    'operator': sm.SCE_C_OPERATOR,
    'commentline': sm.SCE_C_COMMENTLINE,
    'preprocessor': sm.SCE_C_PREPROCESSOR,
    'bracebad': sm.STYLE_BRACEBAD,
    'number': sm.SCE_C_NUMBER,
    'default': sm.SCE_C_DEFAULT,
    'keyword': sm.SCE_C_IDENTIFIER,
    'string': sm.SCE_C_STRING,
    'stringeol': sm.SCE_C_STRINGEOL,
    'bracehighlight': sm.STYLE_BRACELIGHT,
    'comment': sm.SCE_C_COMMENT,
  }, 'Batch': {
    'label': sm.SCE_BAT_LABEL,
    'word': sm.SCE_BAT_WORD,
    'hide': sm.SCE_BAT_HIDE,
    'command': sm.SCE_BAT_COMMAND,
    'comment': sm.SCE_BAT_COMMENT,
    'default': sm.SCE_BAT_DEFAULT,
    'identifier': sm.SCE_BAT_IDENTIFIER,
    'operator': sm.SCE_BAT_OPERATOR,
  }, 'LaTeX': {
    'math': sm.SCE_L_MATH,
    'command': sm.SCE_L_COMMAND,
    'default': sm.SCE_L_DEFAULT,
    'tag': sm.SCE_L_TAG,
    'comment': sm.SCE_L_COMMENT,
  }, 'XML': {
    "default": sm.SCE_XML_DEFAULT,
    "prolog": sm.SCE_XML_PROLOG,
    "start_tag_open": sm.SCE_XML_START_TAG_OPEN,
    "start_tag_name": sm.SCE_XML_START_TAG_NAME,
    "start_tag_close": sm.SCE_XML_START_TAG_CLOSE,
    "start_tag_empty_close": sm.SCE_XML_START_TAG_EMPTY_CLOSE,
    "start_tag_attr_name": sm.SCE_XML_START_TAG_ATTR_NAME,
    "start_tag_attr_equals": sm.SCE_XML_START_TAG_ATTR_EQUALS,
    "start_tag_attr_quot_open": sm.SCE_XML_START_TAG_ATTR_QUOT_OPEN,
    "start_tag_attr_quot_content": sm.SCE_XML_START_TAG_ATTR_QUOT_CONTENT,
    "start_tag_attr_quot_close": sm.SCE_XML_START_TAG_ATTR_QUOT_CLOSE,
    "start_tag_attr_apos_open": sm.SCE_XML_START_TAG_ATTR_APOS_OPEN,
    "start_tag_attr_apos_content": sm.SCE_XML_START_TAG_ATTR_APOS_CONTENT,
    "start_tag_attr_apos_close": sm.SCE_XML_START_TAG_ATTR_APOS_CLOSE,
    "end_tag_open": sm.SCE_XML_END_TAG_OPEN,
    "end_tag_name": sm.SCE_XML_END_TAG_NAME,
    "end_tag_close": sm.SCE_XML_END_TAG_CLOSE,
    "start_tag_attr_number": sm.SCE_XML_START_TAG_ATTR_NUMBER,
    "entity_ref": sm.SCE_XML_ENTITY_REF,
    "char_ref": sm.SCE_XML_CHAR_REF,
    "data_newline": sm.SCE_XML_DATA_NEWLINE,
    "data_chars": sm.SCE_XML_DATA_CHARS,
    "cdata_sect_open": sm.SCE_XML_CDATA_SECT_OPEN,
    "cdata_sect_content": sm.SCE_XML_CDATA_SECT_CONTENT,
    "cdata_sect_close": sm.SCE_XML_CDATA_SECT_CLOSE,
    "comment_open": sm.SCE_XML_COMMENT_OPEN,
    "comment_content": sm.SCE_XML_COMMENT_CONTENT,
    "comment_close": sm.SCE_XML_COMMENT_CLOSE,
    "pi_open": sm.SCE_XML_PI_OPEN,
    "pi_content": sm.SCE_XML_PI_CONTENT,
    "pi_close": sm.SCE_XML_PI_CLOSE,
    "xml_decl_open": sm.SCE_XML_XML_DECL_OPEN,
    "xml_decl_content": sm.SCE_XML_XML_DECL_CONTENT,
    "xml_decl_close": sm.SCE_XML_XML_DECL_CLOSE,
    "bom": sm.SCE_XML_BOM,
    "xpath_tag_name": sm.SCE_XPATH_TAG_NAME,
    "xpath_attr_name": sm.SCE_XPATH_ATTR_NAME,
    "xpath_open": sm.SCE_XPATH_OPEN,
    "xpath_content_quot": sm.SCE_XPATH_CONTENT_QUOT,
    "xpath_content_apos": sm.SCE_XPATH_CONTENT_APOS,
    "xpath_close": sm.SCE_XPATH_CLOSE,
    "start_tag_white_space": sm.SCE_XML_START_TAG_WHITE_SPACE,
    "start_tag_attr_unquoted": sm.SCE_XML_START_TAG_ATTR_UNQUOTED,
    "end_tag_white_space": sm.SCE_XML_END_TAG_WHITE_SPACE,
    "declaration_open": sm.SCE_XML_DECLARATION_OPEN,
    "declaration_type": sm.SCE_XML_DECLARATION_TYPE,
    "decln_white_space": sm.SCE_XML_DECLN_WHITE_SPACE,
    "decln_name": sm.SCE_XML_DECLN_NAME,
    "decln_close": sm.SCE_XML_DECLN_CLOSE,
    "decln_quot_content": sm.SCE_XML_DECLN_QUOT_CONTENT,
    "decln_apos_content": sm.SCE_XML_DECLN_APOS_CONTENT,
    "decln_data_chars": sm.SCE_XML_DECLN_DATA_CHARS,
    "upper_bound": sm.SCE_XML_UPPER_BOUND,
  }, "Eiffel": {
    "default": sm.SCE_EIFFEL_DEFAULT,
    "commentline": sm.SCE_EIFFEL_COMMENTLINE,
    "number": sm.SCE_EIFFEL_NUMBER,
    "word": sm.SCE_EIFFEL_WORD,
    "string": sm.SCE_EIFFEL_STRING,
    "character": sm.SCE_EIFFEL_CHARACTER,
    "operator": sm.SCE_EIFFEL_OPERATOR,
    "identifier": sm.SCE_EIFFEL_IDENTIFIER,
    "stringeol": sm.SCE_EIFFEL_STRINGEOL,
  }, 'Baan': {
    'default': sm.SCE_BAAN_DEFAULT,
    'comment': sm.SCE_BAAN_COMMENT,
    'commentdoc': sm.SCE_BAAN_COMMENTDOC,
    'number': sm.SCE_BAAN_NUMBER,
    'word': sm.SCE_BAAN_WORD,
    'string': sm.SCE_BAAN_STRING,
    'preprocessor': sm.SCE_BAAN_PREPROCESSOR,
    'operator': sm.SCE_BAAN_OPERATOR,
    'word2': sm.SCE_BAAN_WORD2,
    'identifier': sm.SCE_BAAN_IDENTIFIER,
    'stringeol': sm.SCE_BAAN_STRINGEOL,
  }, 'nnCrontab': {
    'default': sm.SCE_NNCRONTAB_DEFAULT,
    'comment': sm.SCE_NNCRONTAB_COMMENT,
    'task': sm.SCE_NNCRONTAB_TASK,
    'section': sm.SCE_NNCRONTAB_SECTION,
    'keyword': sm.SCE_NNCRONTAB_KEYWORD,
    'modifier': sm.SCE_NNCRONTAB_MODIFIER,
    'asterisk': sm.SCE_NNCRONTAB_ASTERISK,
    'number': sm.SCE_NNCRONTAB_NUMBER,
    'string': sm.SCE_NNCRONTAB_STRING,
    'environment': sm.SCE_NNCRONTAB_ENVIRONMENT,
    'identifier': sm.SCE_NNCRONTAB_IDENTIFIER,
  }, 'CSS': {
    'default': sm.SCE_CSS_DEFAULT,
    'tag': sm.SCE_CSS_TAG,
    'class': sm.SCE_CSS_CLASS,
    'pseudoclass': sm.SCE_CSS_PSEUDOCLASS,
    'unknown_pseudoclass': sm.SCE_CSS_UNKNOWN_PSEUDOCLASS,
    'operator': sm.SCE_CSS_OPERATOR,
    'identifier': sm.SCE_CSS_IDENTIFIER,
    'unknown_identifier': sm.SCE_CSS_UNKNOWN_IDENTIFIER,
    'value': sm.SCE_CSS_VALUE,
    'comment': sm.SCE_CSS_COMMENT,
    'id': sm.SCE_CSS_ID,
    'important': sm.SCE_CSS_IMPORTANT,
    'directive': sm.SCE_CSS_DIRECTIVE,
    'doublestring': sm.SCE_CSS_DOUBLESTRING,
    'singlestring': sm.SCE_CSS_SINGLESTRING,
    'bracebad': sm.STYLE_BRACEBAD,
    'bracehighlight': sm.STYLE_BRACELIGHT,
  }, 'Matlab': {
    'default': sm.SCE_MATLAB_DEFAULT,
    'comment': sm.SCE_MATLAB_COMMENT,
    'command': sm.SCE_MATLAB_COMMAND,
    'number': sm.SCE_MATLAB_NUMBER,
    'keyword': sm.SCE_MATLAB_KEYWORD,
    'string': sm.SCE_MATLAB_STRING,
    'operator': sm.SCE_MATLAB_OPERATOR,
    'identifier': sm.SCE_MATLAB_IDENTIFIER,
    }
}
