var cities = {
    Canada: ["Vancouver", "Edmonton", "Winnipeg",
            "Ottawa", "Montreal", "Halifax", "Goose Bay"],
    UnitedStates: ["Seattle", "Portland", "Des Moines",
            "Chicago", "Miami", "Boston",
            "Harrisburg", "Mantoloking"],
    Mexico: ["Mexico City", "Cancún", "Mexicali",
            "Guadalajara", "Monterrey", "Toluca"]
    };

var demo = function() {
    var menus = {};
    // initializing country-specific menu items for all countries
    for (var country in cities) {
        var menuList = [];
        // getting list of cities for current country
        var city_list = cities[country];
        //for each city, create menu data
        for (var i in city_list) {
            menuList.push({text:city_list[i]});
        }
        // create new YUI context menu
        menus[country] = new YAHOO.widget.ContextMenu(country + "menu",
            { itemdata : menuList });
        // when a line is selected, call the onCitySelect function
        menus[country].clickEvent.subscribe(onCitySelect, menus[country], true);
        menus[country].render(document.body);
    }
    
    function onCitySelect(type, args, menu) {
        // args[0] is the event object
        var myTarget = args[0].target;
        // look for an <A> tag inside menu
        if (myTarget.localName.toUpperCase() == "A") {
            var cityName = myTarget.text;
            // id of the element we're clicking on
            var menuId = menu.id;
            // get the country name - without "menu" suffix
            var uniquePart = menuId.substring(0, menuId.length - 4);
            // find the UL element for this country in DOM
            var targetList = document.getElementById("sel" + uniquePart);
            // create a new list item and add a city
            var newItem = document.createElement("LI");
            newItem.appendChild(document.createTextNode(cityName));
            targetList.appendChild(newItem);
            // remove previously selected city from the context menu list
            var menuBody = menu.body.firstChild;
            for (var i = 0; i < menuBody.childNodes.length; i++) {
                var li = menuBody.childNodes[i];
                if (li.firstChild.firstChild.data == cityName) {
                    menuBody.removeChild(menuBody.childNodes[i]);
                    break;
                }
            }
        }
    }

    function onContextMenu(e) {
        e.preventDefault(); // stops the default context menu from appearing
        // determine which country is being clicked on 
        var curr_country = e.target.id;
        var ctxt_menuname = curr_country + "menu";
        // YUI DOM query to find the right-click co-ordinates
        // the context menu is anchored here
        YAHOO.util.Dom.setXY(ctxt_menuname, [e.clientX + 2, e.clientY + 2]);
        // pick a context menu object: Canada, US, or Mexico
        var context_menu = menus[curr_country];
        // show the selected city in the table to the right
        context_menu.show();
    };
    
    // link onContextMenu to the 'flag' object
    YAHOO.util.Event.addListener('flag', "contextmenu", onContextMenu);
};

// start demo when the page is loaded
YAHOO.util.Event.addListener(window, "load", function() {
    demo();
}); 